Subject: Re: [AAA-WG]: Issue #3: Bring back UTF-8 (fwd)

From: Pat Calhoun <[email-masked]>
Date: Tue, 5 Jun 2001 15:30:39 -0700

> I think that the "Derived Data Formats" are something that should be left to
> implementations.  If we want to formalize them, it should be in a different
> draft, and should not be in Diameter's critical path.

Is this actually true? This argument has been made throughout the data type
discussions, and I don't buy it. Let's take the User-Name AVP, whose definition
is:

"  The User-Name AVP (AVP Code 1) [1] is of type OctetString, which
   contains the User-Name.  The value is represented as a UTF-8
   character encoded string in a format consistent with the NAI
   specification [8]."

Note that the second sentence specifically states that this AVP MUST be
encoded in UTF-8 format. If it isn't, then an implementation is NOT conformant.

Therefore, this type does in fact affect the on-the-wire protocol, since although
it doesn't affect the headers, it affects the data encapsulated within the AVP.

DiameterIdentity is another perfect example. Since there aren't sub-types being
defined, I added it to section 2, which is rather odd.

> 
> Currently, we have implemented something similar in XML, anthough Mark has 
> done MUCH more work than we have on formalizing the types.
> 
> So, I guess my vote is that it is a dictionary issue.  Although, that does 
> *not* imply that it cannot be formalized.  Just that it should not be 
> formalized in the core documents. 

I think that it would make much more sense for the author of an application to
define in the specification any sub-types, as opposed to let the creators of
the dictionaries assume the sub-type.

PatC

---

From: David Frascone <[email-masked]>
Date: Tue, 5 Jun 2001 17:46:45 -0500

When I first started objecting to this, it was because proxies did not need
to know about the inner data to be able to proxy the packets.  That is very
far from true now. 

Given that UTF-8, time formats, etc are now part of the core protocol, and
need to be examined by even the dumbest proxies, it would probably be better
to include the subtypes in the core protocol.

"I have been swayed"

:)

-Dave